"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenId4VcVerifierModuleConfig = void 0;
const did_auth_siop_1 = require("@sphereon/did-auth-siop");
const router_1 = require("../shared/router");
class OpenId4VcVerifierModuleConfig {
    constructor(options) {
        var _a;
        this.options = options;
        this.sessionManagerMap = new Map();
        this.eventEmitterMap = new Map();
        this.router = (_a = options.router) !== null && _a !== void 0 ? _a : (0, router_1.importExpress)().Router();
    }
    get baseUrl() {
        return this.options.baseUrl;
    }
    get authorizationEndpoint() {
        var _a, _b;
        // Use user supplied options, or return defaults.
        const userOptions = (_a = this.options.endpoints) === null || _a === void 0 ? void 0 : _a.authorization;
        return Object.assign(Object.assign({}, userOptions), { endpointPath: (_b = userOptions === null || userOptions === void 0 ? void 0 : userOptions.endpointPath) !== null && _b !== void 0 ? _b : '/authorize' });
    }
    // FIXME: rework (no in-memory)
    getSessionManager(agentContext) {
        const val = this.sessionManagerMap.get(agentContext.contextCorrelationId);
        if (val)
            return val;
        const eventEmitter = this.getEventEmitter(agentContext);
        const newVal = new did_auth_siop_1.InMemoryRPSessionManager(eventEmitter);
        this.sessionManagerMap.set(agentContext.contextCorrelationId, newVal);
        return newVal;
    }
    // FIXME: rework (no-memory)
    getEventEmitter(agentContext) {
        const EventEmitterClass = agentContext.config.agentDependencies.EventEmitterClass;
        const val = this.eventEmitterMap.get(agentContext.contextCorrelationId);
        if (val)
            return val;
        const newVal = new EventEmitterClass();
        this.eventEmitterMap.set(agentContext.contextCorrelationId, newVal);
        return newVal;
    }
}
exports.OpenId4VcVerifierModuleConfig = OpenId4VcVerifierModuleConfig;
//# sourceMappingURL=OpenId4VcVerifierModuleConfig.js.map